<template>
	<div class="DownloadStratificationArtifacts">
		<a class="text-body-1" @click="handleClick">Download Layer Files</a>
		<!-- check width makes sense on mobile and desktop -->
		<v-dialog v-model="isDialogVisible" max-width="50em">
			<v-card>
				<v-card-title>Layer Files</v-card-title>
				<v-card-text class="flex-grow-1">
					<ul>
						<li v-for="({ linkUrl, linkText }, i) in downloadLinks" :key="i" class="mb-2">
							<a :href="linkUrl">
								Download {{ linkText }}
								<v-icon>mdi-download</v-icon>
							</a>
						</li>
					</ul>
				</v-card-text>
			</v-card>
		</v-dialog>
	</div>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api';

function toTitleCase(str: string) {
	return str.replace(/\w\S*/g, function (txt) {
		return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
	});
}

const generateDisplayNameFromKey = (artifactKey: string) => {
	const artifactKeyToFriendlyName: { [key: string]: string } = {
		DATE_RANGE_MAX_NDVI: 'NDVI',
	};
	const [name, fileExt] = artifactKey.split('--');
	const formattedName = name.replace(/_/g, ' ');
	const displayName = artifactKeyToFriendlyName[name] ?? toTitleCase(formattedName);
	return `${displayName} ${fileExt}`;
};

export default defineComponent({
	props: {
		artifactKeys: {
			required: true,
			type: Object as () => { [key: string]: string },
		},
	},
	setup(props) {
		const isDialogVisible = ref<boolean>(false);

		const handleClick = () => {
			isDialogVisible.value = true;
		};

		const downloadLinks = Object.keys(props.artifactKeys).map((key) => ({
			linkUrl: props.artifactKeys[key],
			linkText: generateDisplayNameFromKey(key),
		}));

		return { downloadLinks, isDialogVisible, handleClick };
	},
});
</script>

<style>
.DownloadStratificationArtifacts a {
	font-weight: 500;
}
</style>
